/**
 * Das Interface Figure definiert die gemeinsame
 * Schnittstelle fr verschiedene geometrische Figuren.
 * @author fischer
 * @version 1.0
 */
public interface Figure {
    /**
     * Berechnet die Flche der geometrischen Figur
     * @return Die Flche der Figur
     */
    public double area();

    /**
     * Berechnet dem Unfang der Figur, d.h. die Lnge der "Auenkanten".
     * @return der Umfang der Figur.
     */
    public double circumference();

    /**
     * Berechnet, ob die Figure den Punkt mit den angegbenen Koordinaten
     * berdeckt.
     * @param x Die x-Koordinate des zu berprfenden Punktes
     * @param y Die y-Koordinate des zu berprfenden Punktes
     * @return true wenn die Figur den Punkt berdeckt,
     *         false sonst.
     */
    public boolean overlaps(double x, double y);

    /**
     * Liefert einen, die Figur beschreibenden String, mit dem Namen der Figur
     * und den wichtigsten Attributen.
     * @return Eine textuelle Beschreibung der Figur.
     */
    public String toString();
}
