/**
 * Figures
 *
 * This is GPL'd code
 * (c) by Patrick Kilian 2003
 *
 */
import org.vhb.jop.simpleIO.SimpleInput;
/**
 * Eine Klasse die einen Stack mit maximal 100 Eintrgen des Typs Figure zur
 * Verfgung stellt.
 *
 * @author Patrick Kilian
 * @version 0.01
 */
public class Figures {
    // Der Stack von 100 Figure-Objekten
    private static Figure[] stack = new Figure[100];
    private static int last = -1;
    /**
     * Konstruktor der Klasse Figures
     */
    public Figures (){
    }
    /**
     * Fgt dem Stack einen Figur hinzu
     * @param f Eine neue Figure
     */
    public void pushFigure(Figure f) {
        if (last < 99) {
            stack[last+1] = f;
            last++;
        }
    }
    /**
     * Gibt die oberste Figure vom Stack aus und entfernt sie.
     * @return die gelschte Figure
     */
    public Figure popFigure() {
        Figure out = null;
        if (last >= 0) {
            out = stack[last];
            stack[last] = null;
            last--;
        }
        return(out);
    } 
    /**
     * Sortiert den Stack nach Flche.
     * Die Figure mit der grten Flche kommt zuerst
     * Falls der Stack auf deutlich mehr als 100 Eintrge erweitert wird,
     * sollte man Bubblesort durch eine schnellere Methode ersetzen.
     */
    public void sortByArea() {
        int needRun = 1;
        int run = 0;
        Figure temp;
        while (needRun == 1) {
            needRun = 0;
            for(int i = 0; i < last - run; i++) {
                if (stack[i].area() > stack[i+1].area()) {
                    needRun = 1;
                    temp = stack[i+1];
                    stack[i+1] = stack[i];
                    stack[i] = temp;
                }
            }
            run++;
        }
    }
    /**
     * Sortiert den Stack nach Umfang.
     * Die Figure mit dem grten Umfang zuerst
     */
    public void sortByCircumference() {
        int needRun = 1;
        int run = 0;
        Figure temp;
        while (needRun == 1) {
            needRun = 0;
            for(int i = 0; i < last - run; i++) {
                if (stack[i].circumference() > stack[i+1].circumference()) {
                    needRun = 1;
                    temp = stack[i+1];
                    stack[i+1] = stack[i];
                    stack[i] = temp;
                }
            }
            run++;
        }
    }
    /**
     * Erledigt die Endbearbeitung
     */
    private void handle_zero() {
        Figure out;
        sortByArea();
        while ((out = popFigure()) != null) {
            System.out.println(out);
        }
    }
    /**
     * Erledigt das Erzeugen und Einfgen eines Kreises
     */
    private void handle_one() {
        // x-Koordinate des Kreises
        double x;
        // y-Koordinate des Kreises
        double y;
        // Radius des Kreises
        double r;
        System.out.println("Bitte die x-Koordinate des Mittelpunktes");
        x = SimpleInput.in.getDouble();
        System.out.println("Bitte die y-Koordinate des Mittelpunktes");
        y = SimpleInput.in.getDouble();
        System.out.println("Bitte den Radius");
        r = SimpleInput.in.getDouble();
        pushFigure(new Circle(x, y, r));
    }
    /**
     * Erledigt das Erzeugen und Einfgen eines Rechtecks
     */
    private void handle_two() {
        // x-Koordinate des linken unteren Punktes
        double x1;
        // y-Koordinate des linken unteren Punktes
        double y1;
        // x-Koordinate des rechten oberen Punktes
        double x2;
        // y-Koordinate des rechten oberen Punktes
        double y2;
        System.out.println("Bitte die x-Koordinate des linken Punktes");
        x1 = SimpleInput.in.getDouble();
        System.out.println("Bitte die y-Koordinate des unteren Punktes");
        y1 = SimpleInput.in.getDouble();
        System.out.println("Bitte die x-Koordinate des rechten Punktes");
        x2 = SimpleInput.in.getDouble();
        System.out.println("Bitte die y-Koordinate des oberen Punktes");
        y2 = SimpleInput.in.getDouble();
        pushFigure(new Rectangle(x1, y1, x2, y2));
    }
    /**
     * Testmethode die Klasse Figures
     *
     * @param args wird ignoriert
     *
     * Achtung es findet _keine_ Fehlerbehandlung statt.
     */
    public void main(String[] args) {
        int choice;
        int nextRun = 1;
        Figure out;
        System.out.println("Was wollen Sie tun?");
        System.out.println("1: Einen neuen Kreis erstellen.");
        System.out.println("2: Ein neues Rechteck erstellen.");
        System.out.println("0: Die Eingabe von Objekten beenden.");
        choice = SimpleInput.in.getInt();
        while (nextRun == 1) {
            nextRun = 0;
            switch(choice) {
                case 1:
                    nextRun = 1;
                    handle_one();
                    break;
                case 2:
                    nextRun = 1;
                    handle_two();
                    break;
                case 0:
                    handle_zero();
                    break;
                default:
                    System.out.println("Die war eine ungltie Auswahl");
                    break;
            }
        }
    }
}
